
from neo4j import GraphDatabase
import pandas as pd

neoconn = GraphDatabase.driver("bolt://localhost:7687",
    auth=("neo4j","davies4ever"))
session = neoconn.session()

session.run("match (a:Character) detach delete a;")

def add_rels(df, relname):
    for row in df.itertuples():
        session.run(f"""
        merge (a:Character {{name:"{row.char1}" }})
            merge (b:Character {{name:"{row.char2}" }})
            merge (a)-[:{relname} {{loc:"{row.loc}", ep:"{row.ep}"}}]->(b);
        """)

chars = pd.read_csv("chars.csv")
scenes = pd.read_csv("scenesAll.csv")
touches = pd.read_csv("touchesAll.csv")
dialog = pd.read_csv("dialogAll.csv")
mentions = pd.read_csv("mentionsAll.csv")

for char in chars.itertuples():
    session.run(f"""
    create (:Character {{name:"{char.char}",gender:"{char.gender}",
        species:"{char.species}"}});
    """)

add_rels(scenes,"appearsWith")
add_rels(touches,"touches")
add_rels(dialog,"speaksTo")
add_rels(mentions,"mentions")
